/* tnt: Hostmode Terminal for TNC
   Copyright (C) 1993 by Mark Wahl
   For license details see documentation
   Main config file (config.h)
   created: Mark Wahl DL4YBG 94/02/01
   updated: Mark Wahl DL4YBG 94/03/19
*/


/* Operating System definition */

/* define if LINUX used */
#define TNT_LINUX

/* define if Interactive Unix used */
#undef TNT_ISC


/* Special Features definition */

/* define USE_SELECT if select() shall be used, else
   keyboard and serial is polled with sleep
   (CPU-load lower than with select)
   
   define HAS_USLEEP if usleep() is available,
   else select with timeout is used
   
   define HAS_SRANDOM if srandom() is available,
   else srand() is used

   define HAS_INDEX if index() is availbale,
   else strchr() is used

   define HAS_MEMMOVE if memmove() is available,
   else function is emulated by a temporary buffer

   define DEF_AUTO_NEWLINE to 1 if your terminal sets the cursor
   in the new line, if a character in the last column of the line
   was written, else set to 0.

   if DEF_AUTO_NEWLINE is set to 1 and the terminal don't display any
   character for the codes 128-160 DEF_SUPP_HICNTL must be set to 1, else
   set to 0.
         
   define HAS_CRTSCTS if CRTSCTS is available in tcsetattr
   else flag not used
       
   define USE_SOCKET if INET-Sockets available
   
   define HAS_UTHOST if ut_host entry in utmp available
   
   define HAS_UTEXIT if ut_exit entry in utmp available
   
   define TNT_CHAMBER for some special features
   
   DIR_STRING contains command line used for //DIR remote command
 
   DIRL_STRING contains command line used for //DIRLONG remote command
 
   FREE_STRING contains command line used for //FREE remote command
   
*/

#ifdef TNT_LINUX
#undef USE_SELECT
#define HAS_USLEEP
#define HAS_SRANDOM
#define HAS_INDEX
#define HAS_MEMMOVE
#define HAS_CRTSCTS
#define HAS_UTHOST
#undef HAS_UTEXIT
#define USE_SOCKET
#undef READ_NONBLOCK
#undef TNT_CHAMBER
#define DEF_AUTO_NEWLINE 0
#define DEF_SUPP_HICNTL 0
#define DIR_STRING "ls -xaFT80 "
#define DIRL_STRING "ls -laFT80 "
#define FREE_STRING "df 2>/dev/null > "
#include <termcap.h>
#include <linux/wait.h>
#endif

#ifdef TNT_ISC
#define USE_SELECT
#undef HAS_USLEEP
#undef HAS_SRANDOM
#undef HAS_INDEX
#undef HAS_MEMMOVE
#undef HAS_CRTSCTS
#undef HAS_UTHOST
#undef HAS_UTEXIT
#define USE_SOCKET
#define TNT_CHAMBER
#define READ_NONBLOCK
#define DEF_AUTO_NEWLINE 1
#define DEF_SUPP_HICNTL 1
#define DIR_STRING "ls -lF "
#define DIRL_STRING "ls -lF "
#define FREE_STRING "/bin/df2 2>/dev/null > "
#include <termio.h>
#include <sys/bsdtypes.h>
#include <errno.h>
#include <sys/signal.h>
#include <sys/wait.h>
#include <sys/stream.h>
#include <sys/ptem.h>
#define FD_SETSIZE 256
#endif
