/* tnt: Hostmode Terminal for TNC
   Copyright (C) 1993 by Mark Wahl
   For license details see documentation
   include file for keyboard codes (keys.h)
   created: Mark Wahl DL4YBG 94/02/05
   updated: Mark Wahl DL4YBG 94/03/19
*/

#ifdef TNT_LINUX
/* keycodes used if TERM not xterm */
static struct func_keys special_keys[] = {
 {"\033[[A",1,1},		/* F1 */
 {"\033[[B",1,2},		/* F2 */
 {"\033[[C",1,3},		/* F3 */
 {"\033[[D",1,4},		/* F4 */
 {"\033[[E",1,5},		/* F5 */
 {"\033[17~",1,6},		/* F6 */
 {"\033[18~",1,7},		/* F7 */
 {"\033[19~",1,8},		/* F8 */
 {"\033[20~",1,9},		/* F9 */
 {"\033[21~",1,0},		/* F10 */
 {"\033[28~",0,C_MONITOR},	/* F11 */
 {"\033[29~",0,C_COMMAND},	/* F12 */
 {"\033[23~",0,C_MONITOR},	/* F11 */
 {"\033[24~",0,C_COMMAND},	/* F12 xterm */
 {"\033[2~",0,C_INSERT},	/* INSERT */
 {"\033[5~",0,C_WINUP},		/* PAGEUP */
 {"\033[6~",0,C_WINDWN},	/* PAGEDWN */
 {"\033[A",0,C_CUUP},		/* CURSOR UP */
 {"\033[B",0,C_CUDWN},		/* CURSOR DOWN */
 {"\033[C",0,C_CURIGHT},	/* CURSOR RIGHT */
 {"\033[D",0,C_CULEFT}		/* CURSOR LEFT */
};

#define NUMFUNC 21 /* number of function-keys */
#endif

#ifdef TNT_ISC
/* keycodes used if TERM not xterm */
static struct func_keys special_keys[] = {
 {"\033OP",1,1},		/* F1 */
 {"\033OQ",1,2},		/* F2 */
 {"\033OR",1,3},		/* F3 */
 {"\033OS",1,4},		/* F4 */
 {"\033OT",1,5},		/* F5 */
 {"\033OU",1,6},		/* F6 */
 {"\033OV",1,7},		/* F7 */
 {"\033OW",1,8},		/* F8 */
 {"\033OX",1,9},		/* F9 */
 {"\033OY",1,0},		/* F10 */
 {"\033OZ",0,C_MONITOR},	/* F11 */
 {"\033OA",0,C_COMMAND},	/* F12 */
 {"\033[23~",0,C_MONITOR},	/* F11 */
 {"\033[24~",0,C_COMMAND},	/* F12 xterm */
 {"\033[@",0,C_INSERT},		/* INSERT */
 {"\033[V",0,C_WINUP},	        /* PAGEUP */
 {"\033[U",0,C_WINDWN},		/* PAGEDWN */
 {"\033[A",0,C_CUUP},		/* CURSOR UP */
 {"\033[B",0,C_CUDWN},	        /* CURSOR DOWN */
 {"\033[C",0,C_CURIGHT},	/* CURSOR RIGHT */
 {"\033[D",0,C_CULEFT}		/* CURSOR LEFT */
};

#define NUMFUNC 21 /* number of function-keys */
#endif

/* keycodes used if TERM=xterm */
static struct func_keys special_keys_xterm[] = {
 {"\033[11~",1,1},		/* F1 xterm */
 {"\033[12~",1,2},		/* F2 xterm */
 {"\033[13~",1,3},		/* F3 xterm */
 {"\033[14~",1,4},		/* F4 xterm */
 {"\033[15~",1,5},		/* F5 xterm */
 {"\033[28~",1,1},		/* F1 xterm2 */
 {"\033[33~",1,2},		/* F2 xterm2 */
 {"\033[34~",1,3},		/* F3 xterm2 */
 {"\033[29~",1,4},		/* F4 xterm2 */
 {"\033[32~",1,5},		/* F5 xterm2 */
 {"\033[17~",1,6},		/* F6 */
 {"\033[18~",1,7},		/* F7 */
 {"\033[19~",1,8},		/* F8 */
 {"\033[20~",1,9},		/* F9 */
 {"\033[21~",1,0},		/* F10 */
 {"\033[23~",0,C_MONITOR},	/* F11 xterm */
 {"\033[24~",0,C_COMMAND},	/* F12 xterm */
 {"\033[2~",0,C_INSERT},	/* INSERT */
 {"\033[5~",0,C_WINUP},		/* PAGEUP */
 {"\033[6~",0,C_WINDWN},	/* PAGEDWN */
 {"\033[A",0,C_CUUP},		/* CURSOR UP */
 {"\033[B",0,C_CUDWN},		/* CURSOR DOWN */
 {"\033[C",0,C_CURIGHT},	/* CURSOR RIGHT */
 {"\033[D",0,C_CULEFT}		/* CURSOR LEFT */
};

#define NUMFUNC_XTERM 24 /* number of function-keys */
