/* tnt: Hostmode Terminal for TNC
   Copyright (C) 1993 by Mark Wahl
   For license details see documentation
   include file for shell login (shell.h)
   created: Mark Wahl DL4YBG 94/01/22
   updated: Mark Wahl DL4YBG 94/03/17
*/

#define pty_name(name, prefix, num) \
  sprintf(name, "%s%c%x", prefix, 'p' + (num >> 4), num & 0xf)

#define uchar(x) ((x) & 0xff)

#define NUMPTY		256
#define MASTERPREFIX    "/dev/pty"
#define SLAVEPREFIX     "/dev/tty"
#define DEFAULTUSER     "guest"

struct shell_stat {
  int active;           /* flag if shell active */
  int mode;             /* mode during shell command */
  int pty;		/* pty file descriptor */
  int num;              /* pty number */
  char id[4];           /* pty id (last chars) */
  pid_t pid;            /* process id of child */
  int lfcrconv;         /* flag if lf -> cr and vice versa */
  int buflen;           /* number of chars in buffer */
  time_t bufupdate;     /* time of last char written to buffer */
  char buffer[PACKETSIZE]; /* buffer for chars from pty to tnc */
  int connected;        /* flag if port connected (for sockets) */
  int sockfd;           /* socket file descriptor */
};

#define A_SHELL 1
#define A_REDIR 2
#define A_FRONTEND 3
#define A_SOCKET 4

